<?php

$redir_login = '/app/berogui/includes/login.php';
@session_start();
if(!isset($_SESSION['beroari_time']) || ((isset($_SESSION['beroari_time'])) && (($_SESSION['beroari_time']+1200) < time()))) {
	setcookie(session_name(), '', time() - 42000, '/');
	session_unset();
	session_destroy();
	header('Location:' . $redir_login . '?reason=sess_expd&m=rebres');
	exit();
}

$_SESSION['beroari_time'] = time();

// Factory Reset, Datenbank löschen und neu erzeugen
chdir('..');

include('./includes/variables.php');
include('./misc/database.php');
include('/usr/fallback/beroConf.php');

// save sip-settings
if (isset($_POST['keep_sip_set'])){
	$ba = new beroAri();
	$q = $ba->select('SELECT * FROM sip;');

	while ($entry=sqlite_fetch_array($q, SQLITE_ASSOC)){
		unset($fields);
		unset($values);
		foreach ($entry as $key => $val){
			$fields .= ((strlen($fields) == 0) ? '' : ',') . $key;
			$values .= ((strlen($values) == 0) ? '' : ',') . '\'' . sqlite_escape_string($val) . '\'';
		}
		$inserts[] = 'INSERT INTO sip (' . $fields . ') VALUES (' . $values . ');';
	}
}

// save cloud-settings
if (isset($_POST['keep_cloud_set'])){
	$ba = new beroAri();
	$nameArray = array('proxyEnabled', 'proxyAddress', 'proxyPort', 'proxyType', 'proxyUser', 'proxySecret', 'cloudAddress');
	foreach ($nameArray as $name) {
		$cloudSettings[$name]=$ba->get($name);
	}
}

// delete database ari.db
exec('/bin/rm /usr/conf/ari.db');

//delete voip-wizard.conf
exec('/bin/rm /usr/conf/voip-wizard.conf');

// recreate database ari.db
$ba = new beroAri();
if (isset($_POST['keep_sip_set']) || isset($_POST['keep_cloud_set'])) {
	$ba->create_database();
}

if ($ba->is_error()){
	echo '<script>alert("' . $ba->error() .'");</script>';
}

// reset rootdb
$bc = new beroConf('root');
$bc->exec_sql("DELETE FROM root WHERE key NOT IN ('root-version','lan-mtu','lan-iface','lan-ipaddr','lan-netmask','lan-gateway','lan-dhcp','msp-iface','msp-ipaddr','app-image','app-status','ntphost','cloud_enable','cloud_key', 'lan-nameserver','vlan-enable','vlan-id','vlan-prio');");

if (!isset($_POST['keep_set'])) {

	$delArray = array('lan-ipaddr', 'lan-netmask', 'lan-gateway', 'lan-nameserver', 'ntphost', 'vlan-enable', 'vlan-id', 'vlan-prio');
	foreach ($delArray as $delItem) {
		$bc->delete('root', $delItem);
	}
	unset($delArray);

	$bc->set('root', 'lan-iface', 'eth0');
	$bc->set('root', 'lan-dhcp', 'yes');
	$bc->set('root', 'lan-mtu', '1500');
	$bc->set('root', 'beroAvahi-enabled', '1');
}

// set a default ntphost (if none is set, but configuration is static)
if ($bc->get('root', 'lan-dhcp') != 'yes') {
	if (strlen($bc->get('root', 'ntphost')) == 0) {
		$bc->set('root', 'ntphost', 'ntp0.fau.de');
	}
}

if (!isset($_POST['keep_cloud_set'])){
	$bc->exec_sql("DELETE FROM root WHERE key IN ('cloud_enable', 'cloud_key');");
}

if (!isset($_POST['keep_app_set'])){

	exec('/bin/mount -o remount,rw /home/admin/');

	if ($handle = opendir('/home/admin/apps/')) {
		while (false !== ($file = readdir($handle))) {
			if (($file == '.') || ($file == '..')) {
				continue;
			}
			exec('/bin/rm -rf /home/admin/apps/' . $file);
			exec('/bin/rm -rf /home/admin/www/' . $file);
		}
		closedir($handle);
	}

	exec('/bin/rm -rf /usr/conf/userapp');
	exec('sync');
	exec('/bin/mount -o remount,ro /home/admin/');
}

$bc->set('root', 'msp-iface', 'eth1');
$bc->set('root', 'msp-ipaddr', 'auto');
$bc->set('root', 'app-status', 'running');
$bc->set('root', 'userapp-enabled', '1');

// restore sip-settings
if (isset($_POST['keep_sip_set'])) {
	foreach ($inserts as $sql) {
		$ba->insert_($sql);
	}
}

// restore cloud-settings
if (isset($_POST['keep_cloud_set'])) {
	foreach ($cloudSettings as $key => $value) {
		$ba->set($key, sqlite_escape_string($value));
	}
}

// doesn't this belong into 'create_files.php'??
// reset api-password
@unlink('/usr/conf/apiusers.conf');
if (($FP = fopen('/usr/conf/apiusers.conf', 'w')) != null) {
	fputs($FP, 'admin:' . crypt('admin', base64_encode('admin')));
	fclose($FP);
}

// reset password for user admin and deactivate account
exec('/usr/local/sbin/pwchange.sh admin admin');
exec('/bin/mount -oremount,rw /; /usr/bin/passwd -l admin; sync; /bin/mount -oremount,ro /');

echo '<script>window.location.href="' . (($_POST['v'] == 'Wizard') ? '../index.php?m=wizard' : '../includes/create_files.php') . '"</script>';

?>
